# Diary.pm ( neary equal Schedule.pm)
#	Copyright(C)2001 Ktat, All rights reserved.

package Diary;

use strict;
use vars qw($db $db_file);
use Calendar;
require 'jcode.pl';

sub new{
	my $pkg  = shift;
	my $dir  = shift;
	my $year = shift;
	my $month= shift;
	my $admin= shift;
	my $message = '';
	$db_file    = $dir."/".$year.$month.".diary";
	($db,$message) = _read_db();
	bless{
		'dir' 		=> $dir,
		'mode'		=> $admin,
		'message'	=> $message
	},$pkg;
}

sub _read_db{
	my %db;
	my $message = '';
	if(_f_lock("check")){
		if(open DB,$db_file){
			seek DB,0,0;
			while(<DB>){
				chomp;
				my($date,$data) = split /\t/;
				$db{$date} = $data;
			}
		  close DB;
		}
	}else{
		$message = "BUSY (Diary::_read_db)";
	}
	return(\%db,$message);
}

sub rec_db{
	my $self = shift;
	my $judge= 1;
	if(_f_lock("on")){
		if(open DB,">$db_file"){
			seek DB,0,0;
			foreach my $date (keys %{$db}){
				print DB $date."\t".$db->{$date}."\n";
			}
		 close DB;
		}else{
			$self->{message} = "Can't make a new file (Diary::rec_db)";
			$judge = 0;
		}
	_f_lock();
	}else{
		$self->{message} = "Lock was failed (Diary::rec_db)";
		$judge = 0;
	}
	return $judge;
}

sub month_canceld{
	my $self = shift;
	my %RS   = %{shift()};
	my $pass = $RS{pass};
	my $judge= ( $self->_check_pass($pass) == 1 ? unlink($db_file) : "폜o܂łB<br>\n");
	return $judge;
}
sub get_reserved{
	my $self = shift;
	my $date = shift;
	return exists($db->{$date}) ? $db->{$date} : "";
}

sub reserve{
	my $self = shift;
	my %RS = %{shift()};
	my $date = $RS{'Date'};
	my $pass = $RS{'pass'};
	my $subject = $RS{'subject'};
	my $content = $RS{'content'};
	my $weather  = $RS{'Weather'};
	my $w_time  = time;
	if(
		$content ne "" and
		$pass ne "" and
		($self->{'mode'} == 0 or $self->_check_pass($pass) == 1)
	){
		my $judge;
		$pass = do_crypt($pass);
		_decode(\$content,$RS{tag});
		_decode(\$subject,$RS{tag});
		_decode(\$weather,$RS{tag});
		$content=~s/<br>//g	if $RS{br} eq "on";
		$content =~ s/(http:\/\/[A-Za-z0-9\$\#\~\.\/\-\?\=\_\%\&]+)/<a href\=\"$1\" target\=\"\_blank\">$1<\/a>/g	if $RS{link} ne "on";
		if( $db->{$date} and 
			join('',(split /<>/,$db->{$date})[0..2]) eq join('',($subject,$content,$weather))
		){
			$self->{message} = "ݏo܂łB<br>\n";
			$self->{message} .= "ȅ݂łB<br>\n";
			return 0;
		}else{
			$db->{$date} = "$subject<>$content<>$weather<>$w_time";
			return 1;
		}
	}else{
		$self->{message} = "ݏo܂łB<br>\n";
		$self->{message} .= "pX[hłB<br>\n" 					if $pass eq "";
		return 0;
	}
}

sub cancel{
	my $self = shift;
	my %RS = %{shift()};
	my $date = $RS{Date};
	my $pass = $RS{pass};
	my $judge= ( $self->_check_pass($pass) == 1 ? delete($db->{$date}) : "폜o܂łB<br>\n");
	return $judge;
}

sub do_crypt{
	my $pass = shift;
	my $salt = ("A".."Z","a".."z",0..9,'.','/')[rand(64)].("A".."Z","a".."z",0..9,'.','/')[rand(64)];
	return crypt($pass,$salt);
}

sub _check_pass{
	my $self = shift;
	my $pass = shift;
	if(open IN, $self->{dir}."/password"){
		seek IN,0,0;
		my $hpass =<IN>;
		close IN;
		return $hpass eq crypt($pass,$hpass) ? 1 : 0;
	}
	return 0;
}

sub _decode{
	my $value = shift;
	my $tag;
	$$value =~s/%([a-fA-F0-9][a-fA-F0-9])/pack("C", hex($1))/eg;
	jcode::convert($value,'sjis');
	$$value =~ s/\t/ /g;
	if($tag eq "on"){
		$$value =~s/</&lt;/g;
		$$value =~s/>/&gt;/g;
	}
	if($$value=~s/\n/\n/g == $$value=~s/\r/\n/g){
		$$value=~s/\n\n/<br>/g;
	}else{
		$$value=~s/\n/<br>/g;
	}
}

sub _f_lock{ # f_lock("on" or "" or "check")
	# _f_lock("check"):
	#	if the file isn't locked, return 1;
	# 	if the file is locked and is still locked after a few seconds return 0;
	# _f_lock("on"):
	#	if locking the file lock is success , return 1.
	# _f_lock(""):
	#	if unlocking the file is success , return 1.
	my $mode = shift;
	my $w_times = 10;
	my $success = 0;
	$db_file =~m{^(.*)/};
	my $dir = $1;
	my $lock_on = $dir."/lock";
	my $lock_off= $dir."/unlock";
	if($mode eq "check" and -e $lock_off){
		$success = 1;
	}elsif(($mode eq "on" or $mode eq "check") and -e $lock_on){
		my $mtime = time - (stat $lock_on)[9];
		while($mtime < 60){
			sleep 1;
			$mtime = time - (stat $lock_on)[9];
			last if(--$w_times < 0);
		}
		$success = ($mtime >= 60  ? rename $lock_on => $lock_off : 0);
		$success = (open(LOCK,">".$lock_on),close LOCK)		if(-e $lock_on and $success == 1);
	}else{
		$success = ($mode eq "on" ? rename $lock_off => $lock_on : rename $lock_on  => $lock_off);
		$success = (open(LOCK,">".$lock_on),close LOCK)		if(-e $lock_on and $success == 1);
	}
#		$n_time  = time;
#		$success = utime($n_time,$n_time,$lock_on)		if(-e $lock_on and $success == 1);
	return $success;
}

1;

__END__
